﻿//ScriptUISprites#.jsx
//
// В индизайне СС2015 что-то улучшили, и в результате картинка, помещенная в кнопку инструкцией "iconbutton", оказалась сдвинутой вправо.
// Поэтому был долгий поиск, как обойти эту ситуацию.
// идея найдена тут: http://www.indiscripts.com/post/2011/04/sprite-buttons-in-scriptui
////
/// Функция MakeFakeButton - сделана на базе этого скрипта Марка Аутрета.
// myPngButton -- имя файла с видом кнопки в трёх состояниях,
// winLink -- объект в описании окна, с которым будет связана эта кнопка
// myFakeButtonAction -- название функции, которая будет выполнена при щелчке на кнопке.
// Таким образом, это уже готовый программный модуль.
// Ниже есть пример его применения.
function MakeFakeButton (myPngButton, winLink, myFakeButtonAction) { // MakeFakeButton
// Number of vertical sprites
var V_SPRITES = 3;
///
// InDesign CC Flag
const CC_FLAG = +(9 <= parseFloat(app.version));
///
// ScriptUI Image Offset Fixer in InDesign CS6 and earlier
// (This bug has been solved in CC i.e. ScriptUI 6.2.x)
const FIX_OFFSET = CC_FLAG ? 0 : 1;
///
// Force an Image widget to repaint (= onDraw trigger)
// CS4-CS6  ->  just reassigning this.size
// CC       ->  we need to temporarily *change* the size
// Note: using layout.layout(1) would not work anymore in CC
// ---
Image.prototype.refresh = CC_FLAG ?
	function() {
		var wh = this.size;
		this.size = [1+wh[0],1+wh[1]];
		this.size = [wh[0],wh[1]];
		wh = null;
	}:
	function() { this.size = [this.size[0],this.size[1]]; };

// Create the UI

//var myFakeButton = winLink.add("panel");
var myFakeButton = winLink.add("group");
iButton = myFakeButton.add('image', undefined, myPngButton, {state:0});
iSize = iButton.image.size, spriteHeight = iSize[1] /V_SPRITES;

// Window settings
// ---
myFakeButton.margins = 1;
myFakeButton.alignChildren = ['center','center'];
winLink.graphics.backgroundColor = winLink.graphics.newBrush(0, [.92,.94,.96,1]);

// Sprite stuff
// ---
iButton.size = [iSize[0], spriteHeight];

iButton.onDraw = function() {
	var dy = this.properties.state*spriteHeight + FIX_OFFSET;
	this.graphics.drawImage(this.image, 0,-dy);
    };
var mouseEventHandler = function(ev) {
	this.properties.state = ('mouseover'==ev.type)+2*('mousedown'==ev.type);
	this.refresh();
    };
///
iButton.addEventListener('mouseover', mouseEventHandler);
iButton.addEventListener('mousedown', mouseEventHandler);
iButton.addEventListener('mouseup', mouseEventHandler);
iButton.addEventListener('mouseout', mouseEventHandler);
// Let's go!
iButton.addEventListener('click', function() { myFakeButtonAction() } );
///
} // MakeFakeButton
///
// Это пример функции, выполняемой при щелчке на кнопке
function fakeButtonActionInfoPict() { // fakeButtonAction
alert ("InfoPict");
}  // fakeButtonAction
///==============
var myWin = myScriptWindow(); 
if (myWin.show() == 2) exit(); 
/// 
function myScriptWindow() { // myScriptWindow 
var win = new Window ("dialog", "adobeindesign.ru", undefined, {closeButton: true}); 
var myScriptFile = myGetScriptPath(); 
var myScriptFolder = decodeURI(myScriptFile.path); 
/// 
function myGetScriptPath() { // myGetScriptPath 
    try { 
        return app.activeScript; 
        } 
    catch(myError) { 
        return File(myError.fileName); 
        } 
} //myGetScriptPath()
///
var Buttons = win.add ("group"); 
Buttons.orientation = "row"; 
Buttons.alignChildren = ["fill", "fill"]; 
myOKButon = Buttons.add ("button",undefined, "OK"); 
///
var pngButton = File (decodeURI(myScriptFolder + "/" + "InfoPict#.png")); // это получение ссылки на файл с тремя картинками
MakeFakeButton (pngButton, Buttons, fakeButtonActionInfoPict); // это обращение к функции создания кнопки:
               // pngButton - файл с рисунком кнопки в разных состояниях
               // Buttons - название группы в описании окна, куда будет помещена новая кнопка
               // fakeButtonActionInfoPict -- название процедуры, что будет запущена при нажатии этой кнопки
///
myCancelButon = Buttons.add ("button", undefined, "Cancel"); 
return win; 
} // myScriptWindow 
